QuantLib: StrippedOptionletAdapter Class Reference

A free/open-source library for quantitative finance Reference manual - version 1.20

Public Member Functions | List of all members
StrippedOptionletAdapter Class Reference

`#include <ql/termstructures/volatility/optionlet/strippedoptionletadapter.hpp>`

Inheritance diagram for StrippedOptionletAdapter:
[legend]

## Public Member Functions
| StrippedOptionletAdapter (const ext::shared_ptr< StrippedOptionletBase > &)
TermStructure interface
Date | maxDate () const
| the latest date for which the curve can return values
VolatilityTermStructure interface
Rate | minStrike () const
| the minimum strike for which the term structure can return vols
Rate | maxStrike () const
| the maximum strike for which the term structure can return vols
LazyObject interface
void | update ()
void | performCalculations () const
ext::shared_ptr< OptionletStripper > | optionletStripper () const
Observer interface
void | deepUpdate ()
VolatilityType | volatilityType () const
Real | displacement () const
Public Member Functions inherited from OptionletVolatilityStructure
| OptionletVolatilityStructure (BusinessDayConvention bdc=Following, const DayCounter &dc=DayCounter())
| default constructor More...
| OptionletVolatilityStructure (const Date &referenceDate, const Calendar &cal, BusinessDayConvention bdc, const DayCounter &dc=DayCounter())
| initialize with a fixed reference date
| OptionletVolatilityStructure (Natural settlementDays, const Calendar &, BusinessDayConvention bdc, const DayCounter &dc=DayCounter())
| calculate the reference date based on the global evaluation date
virtual | ~OptionletVolatilityStructure ()
Volatility | volatility (const Period &optionTenor, Rate strike, bool extrapolate=false) const
| returns the volatility for a given option tenor and strike rate
Volatility | volatility (const Date &optionDate, Rate strike, bool extrapolate=false) const
| returns the volatility for a given option date and strike rate
Volatility | volatility (Time optionTime, Rate strike, bool extrapolate=false) const
| returns the volatility for a given option time and strike rate
Real | blackVariance (const Period &optionTenor, Rate strike, bool extrapolate=false) const
| returns the Black variance for a given option tenor and strike rate
Real | blackVariance (const Date &optionDate, Rate strike, bool extrapolate=false) const
| returns the Black variance for a given option date and strike rate
Real | blackVariance (Time optionTime, Rate strike, bool extrapolate=false) const
| returns the Black variance for a given option time and strike rate
ext::shared_ptr< SmileSection > | smileSection (const Period &optionTenor, bool extr=false) const
| returns the smile for a given option tenor
ext::shared_ptr< SmileSection > | smileSection (const Date &optionDate, bool extr=false) const
| returns the smile for a given option date
ext::shared_ptr< SmileSection > | smileSection (Time optionTime, bool extr=false) const
| returns the smile for a given option time
Public Member Functions inherited from VolatilityTermStructure
| VolatilityTermStructure (BusinessDayConvention bdc, const DayCounter &dc=DayCounter())
| VolatilityTermStructure (const Date &referenceDate, const Calendar &cal, BusinessDayConvention bdc, const DayCounter &dc=DayCounter())
| initialize with a fixed reference date
| VolatilityTermStructure (Natural settlementDays, const Calendar &cal, BusinessDayConvention bdc, const DayCounter &dc=DayCounter())
| calculate the reference date based on the global evaluation date
virtual BusinessDayConvention | businessDayConvention () const
| the business day convention used in tenor to date conversion
Date | optionDateFromTenor (const Period &) const
| period/date conversion
Public Member Functions inherited from TermStructure
| TermStructure (const DayCounter &dc=DayCounter())
| default constructor More...
| TermStructure (const Date &referenceDate, const Calendar &calendar=Calendar(), const DayCounter &dc=DayCounter())
| initialize with a fixed reference date
| TermStructure (Natural settlementDays, const Calendar &, const DayCounter &dc=DayCounter())
| calculate the reference date based on the global evaluation date
virtual | ~TermStructure ()
virtual DayCounter | dayCounter () const
| the day counter used for date/time conversion
Time | timeFromReference (const Date &date) const
| date/time conversion
virtual Time | maxTime () const
| the latest time for which the curve can return values
virtual const Date & | referenceDate () const
| the date at which discount = 1.0 and/or variance = 0.0
virtual Calendar | calendar () const
| the calendar used for reference and/or option date calculation
virtual Natural | settlementDays () const
| the settlementDays used for reference date calculation
Public Member Functions inherited from Observer
| Observer (const Observer &)
Observer & | operator= (const Observer &)
std::pair< iterator, bool > | registerWith (const ext::shared_ptr< Observable > &)
void | registerWithObservables (const ext::shared_ptr< Observer > &)
Size | unregisterWith (const ext::shared_ptr< Observable > &)
void | unregisterWithAll ()
Public Member Functions inherited from Observable
| Observable (const Observable &)
Observable & | operator= (const Observable &)
void | notifyObservers ()
Public Member Functions inherited from Extrapolator
void | enableExtrapolation (bool b=true)
| enable extrapolation in subsequent calls
void | disableExtrapolation (bool b=true)
| disable extrapolation in subsequent calls
bool | allowsExtrapolation () const
| tells whether extrapolation is enabled
Public Member Functions inherited from LazyObject
void | recalculate ()
void | freeze ()
void | unfreeze ()
void | alwaysForwardNotifications ()

## OptionletVolatilityStructure interface
ext::shared_ptr< SmileSection > | smileSectionImpl (Time optionTime) const
| implements the actual smile calculation in derived classes
Volatility | volatilityImpl (Time length, Rate strike) const
| implements the actual volatility calculation in derived classes

## Additional Inherited Members
Public Types inherited from Observer
typedef boost::unordered_set< ext::shared_ptr< Observable > > | set_type
typedef set_type::iterator | iterator
Protected Member Functions inherited from OptionletVolatilityStructure
virtual ext::shared_ptr< SmileSection > | smileSectionImpl (const Date &optionDate) const
virtual Volatility | volatilityImpl (const Date &optionDate, Rate strike) const
Protected Member Functions inherited from VolatilityTermStructure
void | checkStrike (Rate strike, bool extrapolate) const
| strike-range check
Protected Member Functions inherited from TermStructure
void | checkRange (const Date &d, bool extrapolate) const
| date-range check
void | checkRange (Time t, bool extrapolate) const
| time-range check
Protected Member Functions inherited from LazyObject
virtual void | calculate () const
Protected Attributes inherited from TermStructure
bool | moving_
bool | updated_
Calendar | calendar_
Protected Attributes inherited from LazyObject
bool | calculated_
bool | frozen_
bool | alwaysForward_

## Detailed Description

Adapter class for turning a StrippedOptionletBase object into an OptionletVolatilityStructure.

## Member Function Documentation

## ◆ update()

void update | ( |  | ) |
| virtual

This method must be implemented in derived classes. An instance of Observer does not call this method directly: instead, it will be called by the observables the instance registered with when they need to notify any changes.

Reimplemented from LazyObject.

## ◆ performCalculations()

void performCalculations | ( |  | ) | const
| virtual

This method must implement any calculations which must be (re)done in order to calculate the desired results.

Implements LazyObject.

## ◆ deepUpdate()

void deepUpdate | ( |  | ) |
| virtual

This method allows to explicitly update the instance itself and nested observers. If notifications are disabled a call to this method ensures an update of such nested observers. It should be implemented in derived classes whenever applicable

Reimplemented from Observer.